// @check-time-limit-exceeded: task

#include <iostream>
#include <vector>

using namespace std;

typedef unsigned long long int ull;

#define maxr(a, b) (a) = max((a), (b));
#define minr(a, b) (a) = min((a), (b));

int main(int argc, char const *argv[])
{

  // Read Input
  size_t n;
  cin >> n;
  vector<size_t> A(n);
  size_t tot = 0;
  for (size_t i = 0; i < n; ++i)
  {
    cin >> A[i];
    tot += A[i];
  }

  vector<vector<pair<size_t, size_t>>> P(n + 1);
  vector<size_t> Psum(n + 1);

  P[0].push_back({0, 0});
  Psum[0] = 0;
  for (size_t i = 1; i < n + 1; ++i)
  {
    size_t x_i = Psum[i - 1] + A[i - 1];
    Psum[i] = x_i;
    size_t max_y_i = x_i;
    for (size_t j = i; j > 0; --j)
    {
      for (auto elem : P[j - 1])
      {
        if (elem.first <= (x_i - Psum[j - 1]) && elem.second < max_y_i)
        {
          P[i].push_back({elem.second, x_i - Psum[j - 1]});
          max_y_i = elem.second;
        }
      }
    }
  }

  size_t res = tot;
  for (auto elem : P[n])
    minr(res, (elem.first + elem.second));

  // Print output
  cout << res << endl;

  return 0;
}
